/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
***
***  Contact author(s): abk@cs.ucsd.edu, imarkov@umich.edu
***  Original Affiliation:   UCLA, Computer Science Department,
***                          Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/




#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include "iostream.h"
#include "regGainBucket.h"
#include "genericGainElmt.h"

class TestGainElement : public GenericGainElement {};

int main()
{

    GainList list;
    abkfatal(list.isEmpty(), "list should be empty");
   
    TestGainElement e1;
    TestGainElement e2;
    TestGainElement e3;
    e1._gain = 1;
    e2._gain = 2;
    e3._gain = 3;

    list.push(e1);

    abkfatal(!list.isEmpty(), "list should not be empty");

    cout<<"list with one item on it"<<endl;
    cout<<list;

    list.pop();

    abkfatal(list.isEmpty(), "list should be empty again");

    cout<<"empty list"<<endl;
    cout<<list;


    list.push(e1);
    cout<<"whole list is: ";
    cout<<list;

    cout<<"list of the list is: "<<list.getFirst()<<endl;
    list.push(e2);
    cout<<"whole list is: ";
    cout<<list;
    cout<<"list of the list is: "<<list.getFirst()<<endl;
    list.push(e3);
    cout<<"whole list is: ";
    cout<<list;
    cout<<"list of the list is: "<<list.getFirst()<<endl;

    list.pop();
    cout<<"whole list is: ";
    cout<<list;
    cout<<"list of the list is: "<<list.getFirst()<<endl;
    list.pop();
    cout<<"whole list is: ";
    cout<<list;
    cout<<"first of the list is: "<<list.getFirst()<<endl;
    list.pop();
    cout<<"whole list is: ";
    cout<<list;


    abkfatal(list.isEmpty(), "list should be empty again");


    cout<<endl<<endl<<endl;


    cout<<"adding element#1"<<endl; 
    list.push(e1);
    cout<<list;
    cout<<"removing the first element"<<endl;
    e1.disconnect();
    cout<<list;

    cout<<"adding elements #1 & #2"<<endl;
    list.push(e1);
    list.push(e2);
    cout<<list;
    cout<<"removing the first element"<<endl;
    e2.disconnect();
    cout<<list;

    cout<<"adding element #2"<<endl;
    list.push(e2);
    cout<<list;
    cout<<"removing the second element"<<endl;
    e1.disconnect();
    cout<<list;


    cout<<"adding element #1 and #3"<<endl;
    list.push(e1);
    list.push(e3);
    cout<<list;
    cout<<"removing the second element"<<endl;
    e1.disconnect();
    cout<<list;
    list.push(e1);

    cout<<endl<<endl<<endl;


    TestGainElement e4;
    TestGainElement e5;
    TestGainElement e6;
    e4._gain = 4;
    e5._gain = 5;
    e6._gain = 6;

    GainList listb;

    e1.disconnect();
    e2.disconnect();
    e3.disconnect();

    list.push(e1); 
    list.push(e2); 
    list.push(e3); 

    cout<<"ListA: "<<list<<" ListB: "<<listb<<endl;
    list.insertAhead(listb);
    cout<<"ListA.insertAhead(listB) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl;

    list.insertBehind(listb);
    cout<<"ListA.insertBehind(listB) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl;
     
    cout<<"ListA: "<<list<<" ListB: "<<listb<<endl;
    listb.insertAhead(list);
    cout<<"ListB.insertAhead(listA) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl;
    list.insertBehind(listb);
    cout<<"ListA.insertBehind(listB) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl<<endl;

    listb.push(e4); 

    cout<<"ListA: "<<list<<" ListB: "<<listb<<endl;
    list.insertAhead(listb);
    cout<<"ListA.insertAhead(listB) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl;

    listb.push(e5); 
    cout<<"ListA: "<<list<<" ListB: "<<listb<<endl;
    list.insertBehind(listb);
    cout<<"ListA.insertBehine(listB) "<<endl;
    cout<<" ListA: "<<list<<" ListB: "<<listb<<endl;


    return 1;
}

